diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/sta-wifi-mac.cc ns-3.39/src/wifi/model/sta-wifi-mac.cc
--- ns-3.38/src/wifi/model/sta-wifi-mac.cc	2023-03-16 20:54:23.864869400 -0700
+++ ns-3.39/src/wifi/model/sta-wifi-mac.cc	2023-07-05 14:23:48.121428500 -0700
@@ -27,13 +27,17 @@
 #include "qos-txop.h"
 #include "snr-tag.h"
 #include "wifi-assoc-manager.h"
+#include "wifi-mac-queue.h"
 #include "wifi-net-device.h"
 #include "wifi-phy.h"
 
+#include "ns3/eht-configuration.h"
+#include "ns3/emlsr-manager.h"
 #include "ns3/he-configuration.h"
 #include "ns3/ht-configuration.h"
 #include "ns3/log.h"
 #include "ns3/packet.h"
+#include "ns3/pair.h"
 #include "ns3/pointer.h"
 #include "ns3/random-variable-stream.h"
 #include "ns3/simulator.h"
@@ -94,6 +98,23 @@
                           StringValue("ns3::UniformRandomVariable[Min=50.0|Max=250.0]"),
                           MakePointerAccessor(&StaWifiMac::m_probeDelay),
                           MakePointerChecker<RandomVariableStream>())
+            .AddAttribute(
+                "PowerSaveMode",
+                "Enable/disable power save mode on the given link. The power management mode is "
+                "actually changed when the AP acknowledges a frame sent with the Power Management "
+                "field set to the value corresponding to the requested mode",
+                TypeId::ATTR_GET | TypeId::ATTR_SET, // do not set at construction time
+                PairValue<BooleanValue, UintegerValue>(),
+                MakePairAccessor<BooleanValue, UintegerValue>(&StaWifiMac::SetPowerSaveMode),
+                MakePairChecker<BooleanValue, UintegerValue>(MakeBooleanChecker(),
+                                                             MakeUintegerChecker<uint8_t>()))
+            .AddAttribute("PmModeSwitchTimeout",
+                          "If switching to a new Power Management mode is not completed within "
+                          "this amount of time, make another attempt at switching Power "
+                          "Management mode.",
+                          TimeValue(Seconds(0.1)),
+                          MakeTimeAccessor(&StaWifiMac::m_pmModeSwitchTimeout),
+                          MakeTimeChecker())
             .AddTraceSource("Assoc",
                             "Associated with an access point. If this is an MLD that associated "
                             "with an AP MLD, the AP MLD address is provided.",
@@ -142,6 +163,8 @@
 {
     NS_LOG_FUNCTION(this);
     StartScanning();
+    NS_ABORT_IF(!TraceConnectWithoutContext("AckedMpdu", MakeCallback(&StaWifiMac::TxOk, this)));
+    WifiMac::DoInitialize();
 }
 
 void
@@ -153,6 +176,11 @@
         m_assocManager->Dispose();
     }
     m_assocManager = nullptr;
+    if (m_emlsrManager)
+    {
+        m_emlsrManager->Dispose();
+    }
+    m_emlsrManager = nullptr;
     WifiMac::DoDispose();
 }
 
@@ -194,6 +222,20 @@
     m_assocManager->SetStaWifiMac(this);
 }
 
+void
+StaWifiMac::SetEmlsrManager(Ptr<EmlsrManager> emlsrManager)
+{
+    NS_LOG_FUNCTION(this << emlsrManager);
+    m_emlsrManager = emlsrManager;
+    m_emlsrManager->SetWifiMac(this);
+}
+
+Ptr<EmlsrManager>
+StaWifiMac::GetEmlsrManager() const
+{
+    return m_emlsrManager;
+}
+
 uint16_t
 StaWifiMac::GetAssociationId() const
 {
@@ -241,36 +283,38 @@
 }
 
 void
-StaWifiMac::SendProbeRequest()
+StaWifiMac::SendProbeRequest(uint8_t linkId)
 {
-    NS_LOG_FUNCTION(this);
+    NS_LOG_FUNCTION(this << linkId);
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_MGT_PROBE_REQUEST);
     hdr.SetAddr1(Mac48Address::GetBroadcast());
-    hdr.SetAddr2(GetAddress());
+    hdr.SetAddr2(GetFrameExchangeManager(linkId)->GetAddress());
     hdr.SetAddr3(Mac48Address::GetBroadcast());
     hdr.SetDsNotFrom();
     hdr.SetDsNotTo();
     Ptr<Packet> packet = Create<Packet>();
     MgtProbeRequestHeader probe;
-    probe.SetSsid(GetSsid());
-    probe.SetSupportedRates(GetSupportedRates(SINGLE_LINK_OP_ID));
+    probe.Get<Ssid>() = GetSsid();
+    auto supportedRates = GetSupportedRates(linkId);
+    probe.Get<SupportedRates>() = supportedRates.rates;
+    probe.Get<ExtendedSupportedRatesIE>() = supportedRates.extendedRates;
     if (GetHtSupported())
     {
-        probe.SetExtendedCapabilities(GetExtendedCapabilities());
-        probe.SetHtCapabilities(GetHtCapabilities(SINGLE_LINK_OP_ID));
+        probe.Get<ExtendedCapabilities>() = GetExtendedCapabilities();
+        probe.Get<HtCapabilities>() = GetHtCapabilities(linkId);
     }
-    if (GetVhtSupported(SINGLE_LINK_OP_ID))
+    if (GetVhtSupported(linkId))
     {
-        probe.SetVhtCapabilities(GetVhtCapabilities(SINGLE_LINK_OP_ID));
+        probe.Get<VhtCapabilities>() = GetVhtCapabilities(linkId);
     }
     if (GetHeSupported())
     {
-        probe.SetHeCapabilities(GetHeCapabilities(SINGLE_LINK_OP_ID));
+        probe.Get<HeCapabilities>() = GetHeCapabilities(linkId);
     }
     if (GetEhtSupported())
     {
-        probe.SetEhtCapabilities(GetEhtCapabilities(SINGLE_LINK_OP_ID));
+        probe.Get<EhtCapabilities>() = GetEhtCapabilities(linkId);
     }
     packet->AddHeader(probe);
 
@@ -311,26 +355,28 @@
 
     // lambda to set the fields of the (Re)Association Request
     auto fill = [&](auto&& frame) {
-        frame.SetSsid(GetSsid());
-        frame.SetSupportedRates(GetSupportedRates(linkId));
-        frame.SetCapabilities(GetCapabilities(linkId));
+        frame.template Get<Ssid>() = GetSsid();
+        auto supportedRates = GetSupportedRates(linkId);
+        frame.template Get<SupportedRates>() = supportedRates.rates;
+        frame.template Get<ExtendedSupportedRatesIE>() = supportedRates.extendedRates;
+        frame.Capabilities() = GetCapabilities(linkId);
         frame.SetListenInterval(0);
         if (GetHtSupported())
         {
-            frame.SetExtendedCapabilities(GetExtendedCapabilities());
-            frame.SetHtCapabilities(GetHtCapabilities(linkId));
+            frame.template Get<ExtendedCapabilities>() = GetExtendedCapabilities();
+            frame.template Get<HtCapabilities>() = GetHtCapabilities(linkId);
         }
         if (GetVhtSupported(linkId))
         {
-            frame.SetVhtCapabilities(GetVhtCapabilities(linkId));
+            frame.template Get<VhtCapabilities>() = GetVhtCapabilities(linkId);
         }
         if (GetHeSupported())
         {
-            frame.SetHeCapabilities(GetHeCapabilities(linkId));
+            frame.template Get<HeCapabilities>() = GetHeCapabilities(linkId);
         }
         if (GetEhtSupported())
         {
-            frame.SetEhtCapabilities(GetEhtCapabilities(linkId));
+            frame.template Get<EhtCapabilities>() = GetEhtCapabilities(linkId);
         }
     };
 
@@ -343,16 +389,28 @@
 {
     NS_LOG_FUNCTION(this << isReassoc << +linkId);
 
-    MultiLinkElement multiLinkElement(MultiLinkElement::BASIC_VARIANT,
-                                      isReassoc ? WIFI_MAC_MGT_REASSOCIATION_REQUEST
-                                                : WIFI_MAC_MGT_ASSOCIATION_REQUEST);
+    MultiLinkElement multiLinkElement(MultiLinkElement::BASIC_VARIANT);
     // The Common info field of the Basic Multi-Link element carried in the (Re)Association
     // Request frame shall include the MLD MAC address, the MLD Capabilities and Operations,
     // and the EML Capabilities subfields, and shall not include the Link ID Info, the BSS
     // Parameters Change Count, and the Medium Synchronization Delay Information subfields
     // (Sec. 35.3.5.4 of 802.11be D2.0)
-    // TODO Add the MLD Capabilities and Operations and the EML Capabilities subfields
+    // TODO Add the MLD Capabilities and Operations subfield
     multiLinkElement.SetMldMacAddress(GetAddress());
+
+    if (m_emlsrManager) // EMLSR Manager is only installed if EMLSR is activated
+    {
+        multiLinkElement.SetEmlsrSupported(true);
+        TimeValue time;
+        m_emlsrManager->GetAttribute("EmlsrPaddingDelay", time);
+        multiLinkElement.SetEmlsrPaddingDelay(time.Get());
+        m_emlsrManager->GetAttribute("EmlsrTransitionDelay", time);
+        multiLinkElement.SetEmlsrTransitionDelay(time.Get());
+        // When the Transition Timeout subfield is included in a frame sent by a non-AP STA
+        // affiliated with a non-AP MLD, the Transition Timeout subfield is reserved
+        // (Section 9.4.2.312.2.3 of 802.11be D2.3)
+    }
+
     // For each requested link in addition to the link on which the (Re)Association Request
     // frame is transmitted, the Link Info field of the Basic Multi-Link element carried
     // in the (Re)Association Request frame shall contain the corresponding Per-STA Profile
@@ -421,7 +479,7 @@
         GetWifiRemoteStationManager(linkId)->GetMldAddress(*link.bssid).has_value())
     {
         auto addMle = [&](auto&& frame) {
-            frame.SetMultiLinkElement(GetMultiLinkElement(isReassoc, linkId));
+            frame.template Get<MultiLinkElement>() = GetMultiLinkElement(isReassoc, linkId);
         };
         std::visit(addMle, frame);
     }
@@ -471,7 +529,6 @@
     {
     case ASSOCIATED:
         return;
-        break;
     case SCANNING:
         /* we have initiated active or passive scanning, continue to wait
            and gather beacons or probe responses until the scanning timeout
@@ -521,13 +578,13 @@
     }
     if (m_activeProbing)
     {
-        scanParams.type = WifiScanParams::ACTIVE;
+        scanParams.type = WifiScanType::ACTIVE;
         scanParams.probeDelay = MicroSeconds(m_probeDelay->GetValue());
         scanParams.minChannelTime = scanParams.maxChannelTime = m_probeRequestTimeout;
     }
     else
     {
-        scanParams.type = WifiScanParams::PASSIVE;
+        scanParams.type = WifiScanType::PASSIVE;
         scanParams.maxChannelTime = m_waitBeaconTimeout;
     }
 
@@ -670,6 +727,8 @@
 
     NS_LOG_DEBUG("Set state to UNASSOCIATED and start scanning");
     SetState(UNASSOCIATED);
+    // cancel the association request timer (see issue #862)
+    m_assocRequestEvent.Cancel();
     auto mldAddress = GetWifiRemoteStationManager(linkId)->GetMldAddress(GetBssid(linkId));
     if (GetNLinks() > 1 && mldAddress.has_value())
     {
@@ -733,6 +792,12 @@
     return linkIds;
 }
 
+std::optional<uint8_t>
+StaWifiMac::GetApLinkId(uint8_t linkId) const
+{
+    return GetLink(linkId).apLinkId;
+}
+
 Mac48Address
 StaWifiMac::DoGetLocalAddress(const Mac48Address& remoteAddr) const
 {
@@ -879,6 +944,12 @@
             NotifyRxDrop(packet);
             return;
         }
+        if (!hdr->HasData())
+        {
+            NS_LOG_LOGIC("Received (QoS) Null Data frame: ignore");
+            NotifyRxDrop(packet);
+            return;
+        }
         if (hdr->IsQosData())
         {
             if (hdr->IsQosAmsdu())
@@ -892,7 +963,7 @@
                 ForwardUp(packet, hdr->GetAddr3(), hdr->GetAddr1());
             }
         }
-        else if (hdr->HasData())
+        else
         {
             ForwardUp(packet, hdr->GetAddr3(), hdr->GetAddr1());
         }
@@ -921,12 +992,27 @@
         ReceiveAssocResp(mpdu, linkId);
         break;
 
+    case WIFI_MAC_MGT_ACTION:
+        if (auto [category, action] = WifiActionHeader::Peek(packet);
+            category == WifiActionHeader::PROTECTED_EHT &&
+            action.protectedEhtAction ==
+                WifiActionHeader::PROTECTED_EHT_EML_OPERATING_MODE_NOTIFICATION)
+        {
+            // this is handled by the EMLSR Manager
+            break;
+        }
+
     default:
         // Invoke the receive handler of our parent class to deal with any
         // other frames. Specifically, this will handle Block Ack-related
         // Management Action frames.
         WifiMac::Receive(mpdu, linkId);
     }
+
+    if (m_emlsrManager)
+    {
+        m_emlsrManager->NotifyMgtFrameReceived(mpdu, linkId);
+    }
 }
 
 void
@@ -939,7 +1025,7 @@
     NS_LOG_DEBUG("Beacon received");
     MgtBeaconHeader beacon;
     mpdu->GetPacket()->PeekHeader(beacon);
-    const CapabilityInformation& capabilities = beacon.GetCapabilities();
+    const auto& capabilities = beacon.Capabilities();
     NS_ASSERT(capabilities.IsEss());
     bool goodBeacon;
     if (IsWaitAssocResp() || IsAssociated())
@@ -1028,6 +1114,7 @@
         return;
     }
 
+    std::optional<Mac48Address> apMldAddress;
     MgtAssocResponseHeader assocResp;
     mpdu->GetPacket()->PeekHeader(assocResp);
     if (m_assocRequestEvent.IsRunning())
@@ -1041,11 +1128,11 @@
         UpdateApInfo(assocResp, hdr.GetAddr2(), hdr.GetAddr3(), linkId);
         NS_ASSERT(GetLink(linkId).bssid.has_value() && *GetLink(linkId).bssid == hdr.GetAddr3());
         SetBssid(hdr.GetAddr3(), linkId);
-        if ((GetNLinks() > 1) && assocResp.GetMultiLinkElement().has_value())
+        if ((GetNLinks() > 1) && assocResp.Get<MultiLinkElement>().has_value())
         {
-            // this is an ML setup, trace the MLD address (only once)
-            m_assocLogger(*GetWifiRemoteStationManager(linkId)->GetMldAddress(hdr.GetAddr3()));
+            // this is an ML setup, trace the setup link
             m_setupCompleted(linkId, hdr.GetAddr3());
+            apMldAddress = GetWifiRemoteStationManager(linkId)->GetMldAddress(hdr.GetAddr3());
         }
         else
         {
@@ -1072,7 +1159,7 @@
         }
 
         // if a Multi-Link Element is present, check its content
-        if (const auto& mle = assocResp.GetMultiLinkElement(); mle.has_value())
+        if (const auto& mle = assocResp.Get<MultiLinkElement>())
         {
             NS_ABORT_MSG_IF(!GetLink(linkId).apLinkId.has_value(),
                             "The link on which the Association Response was received "
@@ -1122,13 +1209,9 @@
                     NS_LOG_DEBUG("Setup on link " << staLinkid << " completed");
                     UpdateApInfo(assoc, *bssid, *bssid, staLinkid);
                     SetBssid(*bssid, staLinkid);
-                    if (m_state != ASSOCIATED)
-                    {
-                        m_assocLogger(
-                            *GetWifiRemoteStationManager(staLinkid)->GetMldAddress(*bssid));
-                    }
                     m_setupCompleted(staLinkid, *bssid);
                     SetState(ASSOCIATED);
+                    apMldAddress = GetWifiRemoteStationManager(staLinkid)->GetMldAddress(*bssid);
                     if (!m_linkUp.IsNull())
                     {
                         m_linkUp();
@@ -1149,6 +1232,11 @@
                 GetLink(id).phy->SetOffMode();
             }
         }
+        if (apMldAddress)
+        {
+            // this is an ML setup, trace the MLD address of the AP (only once)
+            m_assocLogger(*apMldAddress);
+        }
     }
 
     if (m_state == WAIT_ASSOC_RESP)
@@ -1157,7 +1245,90 @@
         NS_LOG_DEBUG("association refused");
         SetState(REFUSED);
         StartScanning();
+        return;
     }
+
+    SetPmModeAfterAssociation(linkId);
+}
+
+void
+StaWifiMac::SetPmModeAfterAssociation(uint8_t linkId)
+{
+    NS_LOG_FUNCTION(this << linkId);
+
+    // STAs operating on setup links may need to transition to a new PM mode after the
+    // acknowledgement of the Association Response. For this purpose, we connect a callback to
+    // the PHY TX begin trace to catch the Ack transmitted after the Association Response.
+    CallbackBase cb = Callback<void, WifiConstPsduMap, WifiTxVector, double>(
+        [=](WifiConstPsduMap psduMap, WifiTxVector txVector, double /* txPowerW */) {
+            NS_ASSERT_MSG(psduMap.size() == 1 && psduMap.begin()->second->GetNMpdus() == 1 &&
+                              psduMap.begin()->second->GetHeader(0).IsAck(),
+                          "Expected a Normal Ack after Association Response frame");
+
+            auto ackDuration =
+                WifiPhy::CalculateTxDuration(psduMap, txVector, GetLink(linkId).phy->GetPhyBand());
+
+            for (uint8_t id = 0; id < GetNLinks(); id++)
+            {
+                auto& link = GetLink(id);
+
+                if (!link.bssid)
+                {
+                    // link has not been setup
+                    continue;
+                }
+
+                if (id == linkId)
+                {
+                    /**
+                     * When a link becomes enabled for a non-AP STA that is affiliated with a
+                     * non-AP MLD after successful association with an AP MLD with (Re)Association
+                     * Request/Response  frames transmitted on that link [..], the power management
+                     * mode of the non-AP STA, immediately after the acknowledgement of the
+                     * (Re)Association Response frame [..], is active mode.
+                     * (Sec. 35.3.7.1.4 of 802.11be D3.0)
+                     */
+                    // if the user requested this link to be in powersave mode, we have to
+                    // switch PM mode
+                    if (link.pmMode == WIFI_PM_POWERSAVE)
+                    {
+                        Simulator::Schedule(ackDuration,
+                                            &StaWifiMac::SetPowerSaveMode,
+                                            this,
+                                            std::pair<bool, uint8_t>{true, id});
+                    }
+                    link.pmMode = WIFI_PM_ACTIVE;
+                }
+                else
+                {
+                    /**
+                     * When a link becomes enabled for a non-AP STA that is affiliated with a
+                     * non-AP MLD after successful association with an AP MLD with (Re)Association
+                     * Request/Response frames transmitted on another link [..], the power
+                     * management mode of the non-AP STA, immediately after the acknowledgement of
+                     * the (Re)Association Response frame [..], is power save mode, and its power
+                     * state is doze. (Sec. 35.3.7.1.4 of 802.11be D3.0)
+                     */
+                    // if the user requested this link to be in active mode, we have to
+                    // switch PM mode
+                    if (link.pmMode == WIFI_PM_ACTIVE)
+                    {
+                        Simulator::Schedule(ackDuration,
+                                            &StaWifiMac::SetPowerSaveMode,
+                                            this,
+                                            std::pair<bool, uint8_t>{false, id});
+                    }
+                    link.pmMode = WIFI_PM_POWERSAVE;
+                }
+            }
+        });
+
+    // connect the callback to the PHY TX begin trace to catch the Ack and disconnect
+    // after its transmission begins
+    auto phy = GetLink(linkId).phy;
+    phy->TraceConnectWithoutContext("PhyTxPsduBegin", cb);
+    Simulator::Schedule(phy->GetSifs() + NanoSeconds(1),
+                        [=]() { phy->TraceDisconnectWithoutContext("PhyTxPsduBegin", cb); });
 }
 
 bool
@@ -1169,7 +1340,9 @@
     // lambda to invoke on the current frame variant
     auto check = [&](auto&& mgtFrame) -> bool {
         // check supported rates
-        const SupportedRates& rates = mgtFrame.GetSupportedRates();
+        NS_ASSERT(mgtFrame.template Get<SupportedRates>());
+        const auto rates = AllSupportedRates{*mgtFrame.template Get<SupportedRates>(),
+                                             mgtFrame.template Get<ExtendedSupportedRatesIE>()};
         for (const auto& selector : GetWifiPhy(linkId)->GetBssMembershipSelectorList())
         {
             if (!rates.IsBssMembershipSelectorRate(selector))
@@ -1193,10 +1366,24 @@
 {
     NS_LOG_FUNCTION(this << frame.index() << apAddr << bssid << +linkId);
 
+    // ERP Information is not present in Association Response frames
+    const std::optional<ErpInformation>* erpInformation = nullptr;
+
+    if (const auto* beacon = std::get_if<MgtBeaconHeader>(&frame))
+    {
+        erpInformation = &beacon->Get<ErpInformation>();
+    }
+    else if (const auto* probe = std::get_if<MgtProbeResponseHeader>(&frame))
+    {
+        erpInformation = &probe->Get<ErpInformation>();
+    }
+
     // lambda processing Information Elements included in all frame types
     auto commonOps = [&](auto&& frame) {
-        const CapabilityInformation& capabilities = frame.GetCapabilities();
-        const SupportedRates& rates = frame.GetSupportedRates();
+        const auto& capabilities = frame.Capabilities();
+        NS_ASSERT(frame.template Get<SupportedRates>());
+        const auto rates = AllSupportedRates{*frame.template Get<SupportedRates>(),
+                                             frame.template Get<ExtendedSupportedRatesIE>()};
         for (const auto& mode : GetWifiPhy(linkId)->GetModeList())
         {
             if (rates.IsSupportedRate(mode.GetDataRate(GetWifiPhy(linkId)->GetChannelWidth())))
@@ -1210,11 +1397,10 @@
         }
 
         bool isShortPreambleEnabled = capabilities.IsShortPreamble();
-        if (const auto& erpInformation = frame.GetErpInformation();
-            erpInformation.has_value() && GetErpSupported(linkId))
+        if (erpInformation && erpInformation->has_value() && GetErpSupported(linkId))
         {
-            isShortPreambleEnabled &= !erpInformation->GetBarkerPreambleMode();
-            if (erpInformation->GetUseProtection() != 0)
+            isShortPreambleEnabled &= !(*erpInformation)->GetBarkerPreambleMode();
+            if ((*erpInformation)->GetUseProtection() != 0)
             {
                 GetWifiRemoteStationManager(linkId)->SetUseNonErpProtection(true);
             }
@@ -1243,32 +1429,36 @@
         }
         /* QoS station */
         bool qosSupported = false;
-        const auto& edcaParameters = frame.GetEdcaParameterSet();
+        const auto& edcaParameters = frame.template Get<EdcaParameterSet>();
         if (edcaParameters.has_value())
         {
             qosSupported = true;
             // The value of the TXOP Limit field is specified as an unsigned integer, with the least
             // significant octet transmitted first, in units of 32 Î¼s.
-            SetEdcaParameters(AC_BE,
-                              edcaParameters->GetBeCWmin(),
-                              edcaParameters->GetBeCWmax(),
-                              edcaParameters->GetBeAifsn(),
-                              32 * MicroSeconds(edcaParameters->GetBeTxopLimit()));
-            SetEdcaParameters(AC_BK,
-                              edcaParameters->GetBkCWmin(),
-                              edcaParameters->GetBkCWmax(),
-                              edcaParameters->GetBkAifsn(),
-                              32 * MicroSeconds(edcaParameters->GetBkTxopLimit()));
-            SetEdcaParameters(AC_VI,
-                              edcaParameters->GetViCWmin(),
-                              edcaParameters->GetViCWmax(),
-                              edcaParameters->GetViAifsn(),
-                              32 * MicroSeconds(edcaParameters->GetViTxopLimit()));
-            SetEdcaParameters(AC_VO,
-                              edcaParameters->GetVoCWmin(),
-                              edcaParameters->GetVoCWmax(),
-                              edcaParameters->GetVoAifsn(),
-                              32 * MicroSeconds(edcaParameters->GetVoTxopLimit()));
+            SetEdcaParameters({AC_BE,
+                               edcaParameters->GetBeCWmin(),
+                               edcaParameters->GetBeCWmax(),
+                               edcaParameters->GetBeAifsn(),
+                               32 * MicroSeconds(edcaParameters->GetBeTxopLimit())},
+                              linkId);
+            SetEdcaParameters({AC_BK,
+                               edcaParameters->GetBkCWmin(),
+                               edcaParameters->GetBkCWmax(),
+                               edcaParameters->GetBkAifsn(),
+                               32 * MicroSeconds(edcaParameters->GetBkTxopLimit())},
+                              linkId);
+            SetEdcaParameters({AC_VI,
+                               edcaParameters->GetViCWmin(),
+                               edcaParameters->GetViCWmax(),
+                               edcaParameters->GetViAifsn(),
+                               32 * MicroSeconds(edcaParameters->GetViTxopLimit())},
+                              linkId);
+            SetEdcaParameters({AC_VO,
+                               edcaParameters->GetVoCWmin(),
+                               edcaParameters->GetVoCWmax(),
+                               edcaParameters->GetVoAifsn(),
+                               32 * MicroSeconds(edcaParameters->GetVoTxopLimit())},
+                              linkId);
         }
         GetWifiRemoteStationManager(linkId)->SetQosSupport(apAddr, qosSupported);
 
@@ -1277,7 +1467,8 @@
             return;
         }
         /* HT station */
-        if (const auto& htCapabilities = frame.GetHtCapabilities(); htCapabilities.has_value())
+        if (const auto& htCapabilities = frame.template Get<HtCapabilities>();
+            htCapabilities.has_value())
         {
             if (!htCapabilities->IsSupportedMcs(0))
             {
@@ -1296,7 +1487,7 @@
         // the 2.4 GHz band do not support VHT
         if (GetVhtSupported(linkId))
         {
-            const auto& vhtCapabilities = frame.GetVhtCapabilities();
+            const auto& vhtCapabilities = frame.template Get<VhtCapabilities>();
             // we will always fill in RxHighestSupportedLgiDataRate field at TX, so this can be used
             // to check whether it supports VHT
             if (vhtCapabilities.has_value() &&
@@ -1320,7 +1511,7 @@
             return;
         }
         /* HE station */
-        const auto& heCapabilities = frame.GetHeCapabilities();
+        const auto& heCapabilities = frame.template Get<HeCapabilities>();
         if (heCapabilities.has_value() && heCapabilities->GetSupportedMcsAndNss() != 0)
         {
             GetWifiRemoteStationManager(linkId)->AddStationHeCapabilities(apAddr, *heCapabilities);
@@ -1331,36 +1522,41 @@
                     GetWifiRemoteStationManager(linkId)->AddSupportedMcs(apAddr, mcs);
                 }
             }
-            if (const auto& heOperation = frame.GetHeOperation(); heOperation.has_value())
+            if (const auto& heOperation = frame.template Get<HeOperation>();
+                heOperation.has_value())
             {
                 GetHeConfiguration()->SetAttribute("BssColor",
                                                    UintegerValue(heOperation->GetBssColor()));
             }
         }
 
-        const auto& muEdcaParameters = frame.GetMuEdcaParameterSet();
+        const auto& muEdcaParameters = frame.template Get<MuEdcaParameterSet>();
         if (muEdcaParameters.has_value())
         {
-            SetMuEdcaParameters(AC_BE,
-                                muEdcaParameters->GetMuCwMin(AC_BE),
-                                muEdcaParameters->GetMuCwMax(AC_BE),
-                                muEdcaParameters->GetMuAifsn(AC_BE),
-                                muEdcaParameters->GetMuEdcaTimer(AC_BE));
-            SetMuEdcaParameters(AC_BK,
-                                muEdcaParameters->GetMuCwMin(AC_BK),
-                                muEdcaParameters->GetMuCwMax(AC_BK),
-                                muEdcaParameters->GetMuAifsn(AC_BK),
-                                muEdcaParameters->GetMuEdcaTimer(AC_BK));
-            SetMuEdcaParameters(AC_VI,
-                                muEdcaParameters->GetMuCwMin(AC_VI),
-                                muEdcaParameters->GetMuCwMax(AC_VI),
-                                muEdcaParameters->GetMuAifsn(AC_VI),
-                                muEdcaParameters->GetMuEdcaTimer(AC_VI));
-            SetMuEdcaParameters(AC_VO,
-                                muEdcaParameters->GetMuCwMin(AC_VO),
-                                muEdcaParameters->GetMuCwMax(AC_VO),
-                                muEdcaParameters->GetMuAifsn(AC_VO),
-                                muEdcaParameters->GetMuEdcaTimer(AC_VO));
+            SetMuEdcaParameters({AC_BE,
+                                 muEdcaParameters->GetMuCwMin(AC_BE),
+                                 muEdcaParameters->GetMuCwMax(AC_BE),
+                                 muEdcaParameters->GetMuAifsn(AC_BE),
+                                 muEdcaParameters->GetMuEdcaTimer(AC_BE)},
+                                linkId);
+            SetMuEdcaParameters({AC_BK,
+                                 muEdcaParameters->GetMuCwMin(AC_BK),
+                                 muEdcaParameters->GetMuCwMax(AC_BK),
+                                 muEdcaParameters->GetMuAifsn(AC_BK),
+                                 muEdcaParameters->GetMuEdcaTimer(AC_BK)},
+                                linkId);
+            SetMuEdcaParameters({AC_VI,
+                                 muEdcaParameters->GetMuCwMin(AC_VI),
+                                 muEdcaParameters->GetMuCwMax(AC_VI),
+                                 muEdcaParameters->GetMuAifsn(AC_VI),
+                                 muEdcaParameters->GetMuEdcaTimer(AC_VI)},
+                                linkId);
+            SetMuEdcaParameters({AC_VO,
+                                 muEdcaParameters->GetMuCwMin(AC_VO),
+                                 muEdcaParameters->GetMuCwMax(AC_VO),
+                                 muEdcaParameters->GetMuAifsn(AC_VO),
+                                 muEdcaParameters->GetMuEdcaTimer(AC_VO)},
+                                linkId);
         }
 
         if (!GetEhtSupported())
